<?php

if ( !defined('ABSPATH') ) exit;

require_once ABSPATH . 'wp-admin/includes/screen.php';

function quickcab_load_scripts() {
  wp_enqueue_script('jquery', '', array(), false, true);
  wp_enqueue_script('jquery-ui-datepicker', quickcab_plugin_url('assets/js/jquery-ui.min.js'), array('jquery'), '1.12.1', true);
  wp_enqueue_script('quickcab-wpdk', quickcab_plugin_url('assets/js/wpdk.js'), array(), false, true);
  wp_enqueue_script('moment', quickcab_plugin_url('assets/js/moment.js'), array(), false, true);
  wp_enqueue_script('bootstrap-datepicker', quickcab_plugin_url('assets/js/bootstrap-datepicker.js'), array(), '4.17.37', true);
  wp_enqueue_script('quickcab-script', quickcab_plugin_url('assets/js/quickcab.js'), array('jquery-ui-datepicker', 'quickcab-wpdk'), QUICKCAB_VERSION, true);

  $api_key = quickcab_get_option('google_maps_api_key');

  wp_enqueue_script('quickcab-maps', '//maps.googleapis.com/maps/api/js?key=' . $api_key . '&callback=initForms&libraries=places', array('quickcab-script'), false, true);
  wp_localize_script('quickcab-script', 'quickcab_js_settings', quickcab_get_js_settings_array());
}
add_action('wp_enqueue_scripts', 'quickcab_load_scripts');

function quickcab_load_admin_scripts() {
  $api_key = quickcab_get_option('google_maps_api_key');

  wp_enqueue_script('jquery', array(), false, true);
  wp_enqueue_script('jquery-ui-datepicker', quickcab_plugin_url('assets/js/jquery-ui.min.js'), array('jquery'), '1.12.1', true);
  wp_enqueue_script('jquery-ui-core', array(), false, true);
  wp_enqueue_script('quickcab-wpdk', quickcab_plugin_url('assets/js/wpdk.js'), array(), false, true);
  wp_enqueue_script('moment', quickcab_plugin_url('assets/js/moment.js'), array(), false, true);
  wp_enqueue_script('spectrum', quickcab_plugin_url('assets/js/spectrum.js'), array(), '1.8.0', true);
  wp_enqueue_script('select2', quickcab_plugin_url('assets/js/select2.min.js'), array(), '4.0.3', true);
  wp_enqueue_script('fullcalendar-core', quickcab_plugin_url('assets/js/fullcalendar/core.min.js'), array(), '4.1.0', true);
  wp_enqueue_script('fullcalendar-daygrid', quickcab_plugin_url('assets/js/fullcalendar/daygrid.min.js'), array(), '4.1.0', true);
  wp_enqueue_script('fullcalendar-timegrid', quickcab_plugin_url('assets/js/fullcalendar/timegrid.min.js'), array(), '4.1.0', true);
  wp_enqueue_script('fullcalendar-list', quickcab_plugin_url('assets/js/fullcalendar/list.min.js'), array(), '4.1.0', true);
  wp_enqueue_script('qtip', quickcab_plugin_url('assets/js/qtip2.min.js'), array('jquery'), '3.0.3', true);
  wp_enqueue_script('quickcab-admin-script', quickcab_plugin_url('assets/js/quickcab_admin.js'), array('jquery-ui-datepicker', 'spectrum', 'select2', 'jquery', 'quickcab-wpdk'), QUICKCAB_VERSION, true);
  wp_enqueue_script('quickcab-maps', '//maps.googleapis.com/maps/api/js?key=' . $api_key . '&callback=initMap&libraries=places,drawing&language=' . get_google_maps_locale_code(), array('quickcab-admin-script'), false, true);

  wp_localize_script('quickcab-admin-script', 'quickcab_js_settings', quickcab_get_js_settings_array());
}
add_action('admin_enqueue_scripts', 'quickcab_load_admin_scripts');

function quickcab_load_styles() {
  wp_enqueue_style('quickcab-fonts', quickcab_plugin_url('assets/css/fonts.css'), array(), QUICKCAB_VERSION);
  wp_enqueue_style('bootstrap-datepicker', quickcab_plugin_url('assets/css/bootstrap-datepicker.css'), array(), '4.17.37');
  wp_enqueue_style('quickcab-bootstrap', quickcab_plugin_url('assets/css/bootstrap.css'), array(), '3.3.7');
  wp_enqueue_style('jquery-ui-datepicker', quickcab_plugin_url('assets/css/jquery-ui.min.css'), array(), '1.12.1');
  wp_enqueue_style('quickcab-flat-form', quickcab_plugin_url('assets/css/flat-form.css'), array(), QUICKCAB_VERSION);
  wp_enqueue_style('roboto', '//fonts.googleapis.com/css?family=Roboto');
  wp_enqueue_style('quickcab-form1', quickcab_plugin_url('assets/css/form1.css'), array(), QUICKCAB_VERSION);
  wp_enqueue_style('quickcab-style', quickcab_plugin_url('assets/css/quickcab.css'), array('bootstrap-datepicker', 'jquery-ui-datepicker'), QUICKCAB_VERSION);
}
add_action('wp_enqueue_scripts', 'quickcab_load_styles');

function quickcab_load_admin_styles() {
  wp_enqueue_style('quickcab-fonts', quickcab_plugin_url('assets/css/fonts.css'), array(), QUICKCAB_VERSION);
  wp_enqueue_style('quickcab-bootstrap', quickcab_plugin_url('assets/css/bootstrap.css'), array(), '3.3.7');
  wp_enqueue_style('quickcab-admin-style', quickcab_plugin_url('assets/css/quickcab_admin.css'), array(), QUICKCAB_VERSION);
  wp_enqueue_style('jquery-ui-datepicker', quickcab_plugin_url('assets/css/jquery-ui.min.css'), array(), '1.12.1');
  wp_enqueue_style('spectrum', quickcab_plugin_url('assets/css/spectrum.css'), array(), '1.8.0');
  wp_enqueue_style('select2', quickcab_plugin_url('assets/css/select2.min.css'), array(), '4.0.3');
  wp_enqueue_style('fullcalendar', quickcab_plugin_url('assets/css/fullcalendar/core.min.css'), array(), '4.1.0');
  wp_enqueue_style('fullcalendar-daygrid', quickcab_plugin_url('assets/css/fullcalendar/daygrid.min.css'), array(), '4.1.0');
  wp_enqueue_style('fullcalendar-timegrid', quickcab_plugin_url('assets/css/fullcalendar/timegrid.min.css'), array(), '4.1.0');
  wp_enqueue_style('fullcalendar-list', quickcab_plugin_url('assets/css/fullcalendar/list.min.css'), array(), '4.1.0');
  wp_enqueue_style('qtip2', quickcab_plugin_url('assets/css/qtip2.min.css'), array(), '3.0.3');
}
add_action('admin_enqueue_scripts', 'quickcab_load_admin_styles');

function quickcab_get_js_settings_array() {
  $form_options = QuickCab_Booking_Form::get_form_options();

  return apply_filters('quickcab_js_settings_array', array(
    'form' => array(
      'form_primary_color'               => quickcab_get_option('form_primary_color'),
      'form_secondary_color'             => quickcab_get_option('form_secondary_color'),
      'book_vehicle_button_text'         => esc_html__('Book Now', 'quickcab'),
      'book_vehicle_button_disable_text' => esc_html__('Booking', 'quickcab') . '...'
    ),
    'forms' => $form_options,
    'translations' => array(
      'passengers'                  => esc_html__('passengers', 'quickcab'),
      'suitcases'                   => esc_html__('suitcases', 'quickcab'),
      'total'                       => esc_html__('Total', 'quickcab'),
      'subtotal'                    => esc_html__('Subtotal', 'quickcab'),
      'delete'                      => esc_html__('delete', 'quickcab'),
      'deleting'                    => esc_html__('deleting', 'quickcab') . '...',
      'features'                    => esc_html__('Features', 'quickcab'),
      'are_you_sure_delete_comment' => esc_html__('Are you sure you want to delete this note?', 'quickcab'),
      'remove_tier'                 => esc_html__('Remove Tier', 'quickcab'),
      'at'                          => esc_html__('at', 'quickcab'),
      'remove_time'                 => esc_html__('Remove time', 'quickcab'),
      'remove'                      => esc_html__('remove', 'quickcab'),
      'geofence' => array(
        'no_shape_on_map'           => esc_html__('There is no shape on the map to save.', 'quickcab'),
        'shape_saved'               => esc_html__('Shape saved', 'quickcab'),
        'shape_imported'            => esc_html__('Shape imported', 'quickcab'),
        'shape_deleted'             => esc_html__('Shape deleted', 'quickcab'),
        'select_shape'              => esc_html__('Select a shape', 'quickcab'),
        'delete_geofence_shape'     => esc_html__('Are you sure you want to delete this Geofence Shape?', 'quickcab')
      ),
      'error_submitting_form'       => esc_html__('Error submitting form', 'quickcab'),
      'waypoint'                    => esc_html__('Waypoint', 'quickcab'),
      'miles'                       => esc_html__('miles', 'quickcab'),
      'kilometers'                  => esc_html__('kilometers', 'quickcab'),
      'hour'                        => esc_html__('hour', 'quickcab'),
      'hours'                       => esc_html__('hours', 'quickcab'),
      'minute'                      => esc_html__('minute', 'quickcab'),
      'minutes'                     => esc_html__('minutes', 'quickcab')
    ),
    'currency_symbol'                          => get_woocommerce_currency_symbol(),
    'ajax_url'                                 => admin_url('admin-ajax.php'),
    'uses_miles'                               => quickcab_get_option('distance_units') == 'miles',
    'enforce_autocompelte_country_restriction' => quickcab_get_option('enforce_autocompelte_country_restriction') == 'on',
    'autocomplete_country_restriction'         => quickcab_get_option('autocomplete_country'),
    'on_geofence_edit_page'                    => quickcab_on_post_page('geofence_rule', 'edit'),
    'on_geofence_new_page'                     => quickcab_on_post_page('geofence_rule', 'new'),
    'use_fixed_addresses_starting'             => quickcab_get_option('use_fixed_addresses_starting') == 'on',
    'use_fixed_addresses_destination'          => quickcab_get_option('use_fixed_addresses_destination') == 'on',
    'map_starting_area'                        => quickcab_get_option('map_starting_location'),
    'default_calendar_period'                  => quickcab_get_option('default_calendar_period'),
    'fullcalendar_locale_code'                 => get_fullcalendar_locale_code(),
    'fullcalendar_start_of_week'               => get_option('start_of_week')
  ));
}

function quickcab_head_tags() {
  $booking_forms = QuickCab_Booking_Form::find_all();

  foreach ( $booking_forms as $booking_form ) {
    ?><style>
      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .quickcab-button {
        background: <?php echo $booking_form->get_primary_color(); ?>;
        border: 2px solid <?php echo $booking_form->get_primary_color(); ?>;
        color: <?php echo $booking_form->get_secondary_color(); ?>;
      }

      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .quickcab-button:hover,
      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .quickcab-button:active,
      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .quickcab-button:focus {
        color: <?php echo $booking_form->get_primary_color(); ?>;
        background: <?php echo $booking_form->get_secondary_color(); ?>;
      }

      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .quickcab-button.-inverted {
        color: <?php echo $booking_form->get_primary_color(); ?>;
      }

      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .quickcab-button.-inverted:hover {
        background: <?php echo $booking_form->get_primary_color(); ?>;
        color: <?php echo $booking_form->get_secondary_color(); ?>;
      }

      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .quickcab-map-stats .quickcab-map-stat-val {
        color: <?php echo $booking_form->get_primary_color(); ?>;
      }

      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .quickcab-vehicle-item .quickcab-vehicle-price {
        color: <?php echo $booking_form->get_primary_color(); ?>;
      }

      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .quickcab-header-row .quickcab-header {
        border-bottom: 2px solid <?php echo $booking_form->get_primary_color(); ?>;
      }

      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .quickcab-cart-steps .quickcab-cart-step.active .quickcab-section-number {
        background: <?php echo $booking_form->get_primary_color(); ?>;
        color: <?php echo $booking_form->get_secondary_color(); ?>;
      }

      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .quickcab-cart-steps li.active {
        border-color: <?php echo $booking_form->get_primary_color(); ?>;
      }

      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] a.quickcab-add-waypoint,
      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] a.quickcab-remove-waypoint {
        color: <?php echo $booking_form->get_primary_color(); ?>;
      }

      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] a.quickcab-add-waypoint:hover,
      .quickcab-booking-form[data-form-id="<?php echo $booking_form->get_ID(); ?>"] a.quickcab-remove-waypoint:hover {
        background: <?php echo $booking_form->get_primary_color(); ?>;
        color: #fff;
      }

      .ui-datepicker[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .ui-datepicker-calendar a.ui-state-hover {
        background: <?php echo $booking_form->get_primary_color(); ?>;
        color: <?php echo $booking_form->get_secondary_color(); ?>;
      }

      .ui-datepicker[data-form-id="<?php echo $booking_form->get_ID(); ?>"] .ui-datepicker-calendar a.ui-state-active {
        background: <?php echo $booking_form->get_primary_color(); ?>;
        border-color: <?php echo $booking_form->get_primary_color(); ?>;
        color: <?php echo $booking_form->get_secondary_color(); ?>;
      }
    </style><?php
  }
}
add_action('wp_head', 'quickcab_head_tags');

function quickcab_add_order_details_js_array($js_array) {
  global $post;

  if ( quickcab_on_post_page('shop_order') ) {
    $order = new QuickCab_Order($post->ID);

    return array_merge($js_array, array(
      'order_details' => array(
        'starting_coords' => array(
          'lat' => $order->get_starting_lat(),
          'long' => $order->get_starting_long()
        ),
        'destination_coords' => array(
          'lat' => $order->get_destination_lat(),
          'long' => $order->get_destination_long()
        ),
        'starting_address' => $order->get_starting_address(),
        'destination_address' => $order->get_destination_address(),
        'waypoints' => $order->get_waypoints()
      )
    ));
  }

  return $js_array;
}
add_filter('quickcab_js_settings_array', 'quickcab_add_order_details_js_array');
